"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const RedoButton_1 = tslib_1.__importDefault(require("../RedoButton/RedoButton"));
const ShareButton_1 = tslib_1.__importDefault(require("../ShareButton/ShareButton"));
const context_1 = tslib_1.__importDefault(require("../CioQuiz/context"));
const ResultFilters_1 = tslib_1.__importDefault(require("../ResultFilters/ResultFilters"));
const ZeroResults_1 = tslib_1.__importDefault(require("../ZeroResults/ZeroResults"));
const Results_1 = tslib_1.__importDefault(require("../Results/Results"));
const Spinner_1 = tslib_1.__importDefault(require("../Spinner/Spinner"));
function ResultContainer(props) {
    var _a, _b, _c, _d, _e, _f, _g;
    const { resultCardOptions, onShare, resultsPageOptions } = props;
    const { state } = (0, react_1.useContext)(context_1.default);
    const { resultCardSalePriceKey, resultCardRegularPriceKey, resultCardRatingCountKey, resultCardRatingScoreKey, renderResultCardPriceDetails, } = resultCardOptions || {};
    const numberOfResults = (_c = (_b = (_a = state === null || state === void 0 ? void 0 : state.quiz.results) === null || _a === void 0 ? void 0 : _a.response) === null || _b === void 0 ? void 0 : _b.results) === null || _c === void 0 ? void 0 : _c.length;
    const resultsConfig = state === null || state === void 0 ? void 0 : state.quiz.resultsConfig;
    const zeroResults = !numberOfResults;
    let resultsTitle;
    if (zeroResults) {
        resultsTitle = '';
    }
    else if (resultsConfig === null) {
        resultsTitle = 'Here are your results';
    }
    else if ((_d = resultsConfig === null || resultsConfig === void 0 ? void 0 : resultsConfig.desktop.title) === null || _d === void 0 ? void 0 : _d.is_active) {
        resultsTitle = (_e = resultsConfig.desktop.title.text) !== null && _e !== void 0 ? _e : '';
    }
    else {
        resultsTitle = '';
    }
    let resultsDescription;
    if (zeroResults) {
        resultsDescription = '';
    }
    else if (resultsConfig === null) {
        resultsDescription = '';
    }
    else if ((_f = resultsConfig === null || resultsConfig === void 0 ? void 0 : resultsConfig.desktop.description) === null || _f === void 0 ? void 0 : _f.is_active) {
        resultsDescription = (_g = resultsConfig.desktop.description.text) !== null && _g !== void 0 ? _g : '';
    }
    else {
        resultsDescription = '';
    }
    if (state === null || state === void 0 ? void 0 : state.quiz.results) {
        return (react_1.default.createElement("div", { className: 'cio-results-container' },
            react_1.default.createElement("div", { className: 'cio-results-title-container' },
                react_1.default.createElement("h1", { className: 'cio-results-title' }, resultsTitle),
                react_1.default.createElement("p", { className: 'cio-results-description' }, resultsDescription)),
            react_1.default.createElement("div", { className: 'cio-results-filter-and-redo-container cio-results-button-group' },
                react_1.default.createElement(ResultFilters_1.default, { hasNoResults: zeroResults }),
                react_1.default.createElement("div", { className: 'cio-results-redo-and-share-button-group' },
                    react_1.default.createElement(RedoButton_1.default, null),
                    (resultsPageOptions === null || resultsPageOptions === void 0 ? void 0 : resultsPageOptions.showShareResultsButton) && react_1.default.createElement(ShareButton_1.default, { onClick: onShare }))),
            !zeroResults && (react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement("div", { className: 'cio-results-num-results' },
                    numberOfResults,
                    " ",
                    numberOfResults === 1 ? 'result' : 'results'),
                react_1.default.createElement(Results_1.default, { resultCardSalePriceKey: resultCardSalePriceKey, resultCardRegularPriceKey: resultCardRegularPriceKey, resultCardRatingCountKey: resultCardRatingCountKey, resultCardRatingScoreKey: resultCardRatingScoreKey, renderResultCardPriceDetails: renderResultCardPriceDetails }))),
            zeroResults && react_1.default.createElement(ZeroResults_1.default, null)));
    }
    return (react_1.default.createElement("div", { className: 'cio-results-container' },
        react_1.default.createElement(Spinner_1.default, null)));
}
exports.default = ResultContainer;
