import { useCallback } from 'react';
import { QuestionTypes, QuizAPIActionTypes, } from '../../components/CioQuiz/actions';
import useQueryParams from '../useQueryParams';
const useQuizResetClick = (props) => {
    const { resetQuizSessionStorageState, dispatchLocalState, dispatchApiState, quizResults } = props;
    const { removeSharedResultsQueryParams, isSharedResultsQuery } = useQueryParams();
    const quizResetClickHandler = useCallback(() => {
        if (quizResults) {
            dispatchLocalState({
                type: QuestionTypes.Reset,
            });
            dispatchApiState({
                type: QuizAPIActionTypes.RESET_QUIZ,
            });
            resetQuizSessionStorageState();
            if (isSharedResultsQuery)
                removeSharedResultsQueryParams();
        }
    }, [
        dispatchLocalState,
        dispatchApiState,
        resetQuizSessionStorageState,
        quizResults,
        removeSharedResultsQueryParams,
        isSharedResultsQuery,
    ]);
    return quizResetClickHandler;
};
export default useQuizResetClick;
